/*
 * FontTest.java
 *
 * Created on 19 de diciembre de 2003, 16:59
 */

package tests.graphics.font;

import org.jtgl.core.*;
import org.jtgl.micro.*;

/**
 * Font tests
 * @author  Manuel Polo (manuel_polo at yahoo dot es)
 */
public class FontTest extends Mapplet{  
    
    public void start() {        
        JTGLGraphics g = getGraphics();
        debugMsg("Default font: "+g.getDefaultFont());        
        g.begin();
        g.clear();
        g.drawRect(getGraphics().getClip().addDimension(-1));
        JTGLFont font = g.getFont();  
        String [] fontNames = font.getAvailableFontNames(); 
        int y = 0;
        if(fontNames != null)
            for(int i = 0; i < fontNames.length ; i++){
                String fontName = fontNames[i];  
                debugMsg(fontName);
                font = font.createFont(fontName, JTGLFont.STYLE_BOLD | JTGLFont.STYLE_ITALIC | JTGLFont.STYLE_UNDERLINED);
                draw(g, font,y);
                y += font.getHeight();
                flushGraphics();
            }
        else {
            y = (g.getHeight()>>1) - font.getHeight();
            draw(g, font,y);
            y += font.getHeight();
            font = font.createFont(font.getName(), JTGLFont.STYLE_BOLD | JTGLFont.STYLE_ITALIC | JTGLFont.STYLE_UNDERLINED);            
            draw(g, font,y);
            flushGraphics();
        }
        g.end();
    }
    
    private void draw(JTGLGraphics g,JTGLFont font,int y){
        g.setFont(font);
        g.drawString(font.getName() , (g.getWidth() >> 1) - (font.stringWidth(font.getName()) >> 1) , y);        
    }        
}
